local Slider = import('/lua/maui/slider.lua').Slider
local originalCreateUI = CreateUI

function CreateUI(isReplay)
	originalCreateUI(isReplay)
end

local originalOnSelectionChanged = OnSelectionChanged
local StatSlider = false
local EntityTable = false

function OnSelectionChanged(oldSelection, newSelection, added, removed)
	if StatSlider then
		StatSlider:Destroy()
		StatSlider = false
	end
	import('/lua/ui/game/gamemain.lua').GetGameParent().HandleEvent = function(self, event)
		if event.Type=="ButtonPress" and event.Modifiers.Right and not StatSlider then
			for k, selection in newSelection do
				if EntityCategoryContains(categories.SHIELD * categories.STRUCTURE,selection) then
					if not EntityTable then
						EntityTable = {}
					end
					if not table.find(EntityTable, selection:GetEntityId()) then
						EntityTable[selection:GetEntityId()] = {}
					end
					if not selection.Size then
						selection.Size = selection:GetBlueprint().Defense.Shield.ShieldSize
					end
					if not StatSlider then
						parent = import('/lua/ui/game/gamemain.lua').GetGameParent()
						StatSlider = Slider(parent, false,1, 151, UIUtil.SkinnableFile('/slider02/slider_btn_up.dds'), UIUtil.SkinnableFile('/slider02/slider_btn_over.dds'), UIUtil.SkinnableFile('/slider02/slider_btn_down.dds'), UIUtil.SkinnableFile('/slider02/slider-back_bmp.dds'))  
						StatSlider.Left:Set(event.MouseX-95)
						StatSlider.Top:Set(event.MouseY+30)
						StatSlider:SetValue(CalculateValue(selection))
					--	LOG(selection.Size / selection:GetBlueprint().Defense.Shield.ShieldSize * 100)
					end
				end
			end
        elseif	event.Type=="ButtonPress" and StatSlider and not StatSlider:IsHidden() then
        	for k, selection in newSelection do
        		selection.Size = CalculateSize(selection)
        		EntityTable[selection:GetEntityId()] = selection.Size
        	end
			SimCallback( { Func="SetShieldSize",
						   Args={ EntityTable= EntityTable,
                           }
                         }
                       )

        	StatSlider:Destroy()
        	StatSlider = false
        	EntityTable = false
		end
	end
    originalOnSelectionChanged(oldSelection, newSelection, added, removed)
end

CalculateSizes = function(selection)
 	local bp = selection:GetBlueprint()
	local x,y,z = bp.SizeX*2,bp.SizeY*2,bp.SizeZ*2
	local minsize = math.sqrt(math.pow(x, 2) + math.pow(y, 2) + math.pow(z, 2))
	local maxsize =  bp.Defense.Shield.ShieldSize * 1.5
	local normalsize = bp.Defense.Shield.ShieldSize
 --	LOG('Minsize ; ', minsize)
-- 	LOG('Maxsize ; ', maxsize)
	return minsize, maxsize
end

CalculateSize = function(selection)
	local minsize, maxsize = CalculateSizes(selection)
	local value = StatSlider:GetValue()
	local statmin,statmax = StatSlider._startValue,StatSlider._endValue
	local size = minsize + (( (maxsize-minsize)/(statmax-statmin)  ) * (value - statmin))
	--LOG('Size ; ', size)
	return size
end

CalculateValue = function(selection)
	local minsize, maxsize = CalculateSizes(selection)
	local statmin,statmax = StatSlider._startValue,StatSlider._endValue
	local value = selection.Size
	local size = statmin + (( (statmax-statmin)/(maxsize-minsize)  ) * (value - minsize))
	--LOG('Value ; ', size)
	return size
end